create table artikel (artikel_id int identity, titel varchar(255) not null, beschreibung varchar(5000) null, typ char(1) not null, erstellt_am bigint not null, erstellt_von varchar(50) not null);
create table zeitschrift (artikel_id int not null, herausgeber varchar(255) not null);
create table video (artikel_id int not null, abspieldauer int null, fsk SMALLINT null, medium char(1) null);
create table cd (artikel_id int not null, abspieldauer int not null);
create table buch (artikel_id int not null, autoren varchar(1000) null, isbn varchar(50) not null);
create table exemplar (exemplar_id int identity, artikel_id int not null, bestand boolean not null, besitzer_id int not null);
create table besitzer (besitzer_id int identity, typ char(1) not null);
create table filiale (besitzer_id int not null, name varchar(255) not null, plz int not null, ort varchar(255) not null, strasse varchar(255) not null);
create table person (besitzer_id int not null, user_id varchar(50) not null);
create table reservierung (r_id bigint identity, nummer char(8) not null, erstellt_am bigint not null, besitzer_id int not null, ablauf bigint not null, artikel_id int not null, aus_filiale int not null);
create table ausleihe (leih_id bigint identity, erstellt_am bigint not null, besitzer_id int not null, ablauf bigint not null, exemplar_id int not null, status char(1) null);

CREATE UNIQUE INDEX idx_titel ON artikel (titel);
CREATE UNIQUE INDEX idx_userId ON person (user_id);
CREATE UNIQUE INDEX idx_filialeName ON filiale (name);

ALTER TABLE zeitschrift ADD FOREIGN KEY (artikel_id) REFERENCES artikel(artikel_id);
ALTER TABLE video ADD FOREIGN KEY (artikel_id) REFERENCES artikel(artikel_id);
ALTER TABLE cd ADD FOREIGN KEY (artikel_id) REFERENCES artikel(artikel_id);
ALTER TABLE buch ADD FOREIGN KEY (artikel_id) REFERENCES artikel(artikel_id);
ALTER TABLE exemplar ADD FOREIGN KEY (artikel_id) REFERENCES artikel(artikel_id);
ALTER TABLE exemplar ADD FOREIGN KEY (besitzer_id) REFERENCES besitzer(besitzer_id);
ALTER TABLE filiale ADD FOREIGN KEY (besitzer_id) REFERENCES besitzer(besitzer_id);
ALTER TABLE person ADD FOREIGN KEY (besitzer_id) REFERENCES besitzer(besitzer_id);
ALTER TABLE reservierung ADD FOREIGN KEY (aus_filiale) REFERENCES besitzer(besitzer_id);
ALTER TABLE reservierung ADD FOREIGN KEY (besitzer_id) REFERENCES besitzer(besitzer_id);
ALTER TABLE reservierung ADD FOREIGN KEY (artikel_id) REFERENCES artikel(artikel_id);
ALTER TABLE ausleihe ADD FOREIGN KEY (besitzer_id) REFERENCES besitzer(besitzer_id);
ALTER TABLE ausleihe ADD FOREIGN KEY (exemplar_id) REFERENCES exemplar(exemplar_id);