package de.cnam.jemina.extern.auth;

/**
 * Schnittstelle an Fremdsystem f&uuml;r die Benutzerdaten
 * @author CNAM Team (Nadine, Mike, Jens)
 * @since 20.01.2013
 */
public interface IUserDirectory {
    
    /**
     * <p>&Uuml;berpr&uuml;ft die Anmeldedaten.</p>
     * <p>Sind diese korrekt, werden die {@link IUser Benutzerdaten} &uuml;bermittelt.
     * Ansonsten wird <b>null</b> &uuml;bergeben.</p>
     * @param username Benutzername
     * @param password Passwort
     * @return <b>null</b> wenn Benutzer nicht gefunden oder Passwort falsch, ansonsten die {@link IUser Benutzerdaten}
     */
    public IUser checkLogin(String username, String password);

}
